Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/__init__.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/__init__.py	(revision 7375)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/__init__.py	(revision 7376)
@@ -7,7 +7,5 @@
     )
 from waeup.sirp.applicants.container import ApplicantsContainer
-from waeup.sirp.applicants.root import (
-    ApplicantsRoot, get_applicant_data, application_exists,
-    )
+from waeup.sirp.applicants.root import ApplicantsRoot
 from waeup.sirp.applicants.dynamicroles import (
     ApplicantPrincipalRoleManager,)
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/applicant.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/applicant.py	(revision 7375)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/applicant.py	(revision 7376)
@@ -127,5 +127,5 @@
     grok.context(IApplicant)
 
-    access_code = index.Field(attribute='access_code')
+    #access_code = index.Field(attribute='access_code')
     applicant_id = index.Field(attribute='applicant_id')
     reg_number = index.Field(attribute='reg_number')
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/interfaces.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/interfaces.py	(revision 7375)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/interfaces.py	(revision 7376)
@@ -172,10 +172,10 @@
         )
 
-    ac_prefix = schema.Choice(
-        title = u'Access code prefix',
-        required = True,
-        default = None,
-        source = application_pins_vocab,
-        )
+    #ac_prefix = schema.Choice(
+    #    title = u'Activation code prefix',
+    #    required = True,
+    #    default = None,
+    #    source = application_pins_vocab,
+    #    )
 
     application_category = schema.Choice(
@@ -300,9 +300,9 @@
         source = contextual_reg_num_source,
         )
-    access_code = schema.TextLine(
-        title = u'Access Code',
-        required = False,
-        readonly = True,
-        )
+    #access_code = schema.TextLine(
+    #    title = u'Activation Code',
+    #    required = False,
+    #    readonly = True,
+    #    )
     firstname = schema.TextLine(
         title = u'First Name',
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_browser.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_browser.py	(revision 7375)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_browser.py	(revision 7376)
@@ -79,5 +79,5 @@
         # Add an applicants container
         applicantscontainer = ApplicantsContainer()
-        applicantscontainer.ac_prefix = 'APP'
+        #applicantscontainer.ac_prefix = 'APP'
         applicantscontainer.code = u'app2009'
         applicantscontainer.prefix = 'app'
@@ -243,5 +243,5 @@
         self.browser.getControl(name="form.provider").value = [
             'waeup.sirp.applicants.ApplicantsContainer']
-        self.browser.getControl(name="form.ac_prefix").value = ['APP']
+        #self.browser.getControl(name="form.ac_prefix").value = ['APP']
         self.browser.getControl(name="form.application_category").value = ['basic']
         self.browser.getControl("Add applicants container").click()
@@ -255,5 +255,5 @@
         self.browser.getControl(name="form.provider").value = [
             'waeup.sirp.applicants.ApplicantsContainer']
-        self.browser.getControl(name="form.ac_prefix").value = ['APP']
+        #self.browser.getControl(name="form.ac_prefix").value = ['APP']
         self.browser.getControl(name="form.application_category").value = ['basic']
         self.browser.getControl("Add applicants container").click()
@@ -269,5 +269,5 @@
         self.browser.getControl(name="form.provider").value = [
             'waeup.sirp.applicants.ApplicantsContainer']
-        self.browser.getControl(name="form.ac_prefix").value = ['APP']
+        #self.browser.getControl(name="form.ac_prefix").value = ['APP']
         self.browser.getControl(name="form.application_category").value = ['basic']
         self.browser.getControl("Add applicants container").click()