Index: main/waeup.custom/trunk/src/waeup/__init__.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/__init__.py	(revision 7418)
+++ main/waeup.custom/trunk/src/waeup/__init__.py	(revision 7419)
@@ -1,3 +1,19 @@
-# namespace package boilerplate
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
 try:
     import pkg_resources
Index: main/waeup.custom/trunk/src/waeup/custom/browser/pages.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/browser/pages.py	(revision 7418)
+++ main/waeup.custom/trunk/src/waeup/custom/browser/pages.py	(revision 7419)
@@ -1,2 +1,19 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
 import grok
 from waeup.sirp.browser.pages import (
Index: main/waeup.custom/trunk/src/waeup/custom/browser/resources.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/browser/resources.py	(revision 7418)
+++ main/waeup.custom/trunk/src/waeup/custom/browser/resources.py	(revision 7419)
@@ -1,2 +1,19 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
 import grok
 from waeup.sirp.browser.resources import (
Index: main/waeup.custom/trunk/src/waeup/custom/browser/tests.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/browser/tests.py	(revision 7418)
+++ main/waeup.custom/trunk/src/waeup/custom/browser/tests.py	(revision 7419)
@@ -1,2 +1,19 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
 import tempfile
 import shutil
Index: main/waeup.custom/trunk/src/waeup/custom/browser/theming.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/browser/theming.py	(revision 7418)
+++ main/waeup.custom/trunk/src/waeup/custom/browser/theming.py	(revision 7419)
@@ -1,2 +1,4 @@
+## $Id$
+##
 ## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
 ## This program is free software; you can redistribute it and/or modify
@@ -4,10 +6,10 @@
 ## the Free Software Foundation; either version 2 of the License, or
 ## (at your option) any later version.
-## 
+##
 ## This program is distributed in the hope that it will be useful,
 ## but WITHOUT ANY WARRANTY; without even the implied warranty of
 ## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ## GNU General Public License for more details.
-## 
+##
 ## You should have received a copy of the GNU General Public License
 ## along with this program; if not, write to the Free Software
@@ -19,5 +21,5 @@
 
 class CustomTheme1(grok.GlobalUtility):
-    """A custom theme based on the WAeUP base theme.
+    """A custom theme based on the SIRP base theme.
     """
     grok.implements(ITheme)
Index: main/waeup.custom/trunk/src/waeup/custom/configuration.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/configuration.py	(revision 7418)
+++ main/waeup.custom/trunk/src/waeup/custom/configuration.py	(revision 7419)
@@ -1,2 +1,19 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
 """
 Containers for session configuration objects.
Index: main/waeup.custom/trunk/src/waeup/custom/interfaces.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/interfaces.py	(revision 7418)
+++ main/waeup.custom/trunk/src/waeup/custom/interfaces.py	(revision 7419)
@@ -1,7 +1,22 @@
+## $Id$
 ##
-## interfaces.py
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
 from zope import schema
 from waeup.sirp.interfaces import (
-    IWAeUPObject, ISessionConfiguration, academic_sessions_vocab)
+    ISIRPObject, ISessionConfiguration, academic_sessions_vocab)
 
 # It's recommended to replicate all fields from the base package here.
Index: main/waeup.custom/trunk/src/waeup/custom/students/tests.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/students/tests.py	(revision 7418)
+++ main/waeup.custom/trunk/src/waeup/custom/students/tests.py	(revision 7419)
@@ -1,2 +1,19 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
 from waeup.custom.testing import FunctionalLayer
 from waeup.sirp.students.tests.test_browser import StudentsFullSetup
@@ -35,13 +52,24 @@
         self.assertMatches('...ticket created...',
                            self.browser.contents)
+        ctrl = self.browser.getControl(name='val_id')
+        value = ctrl.options[0]
+        self.browser.getLink(value).click()
+        self.assertMatches('...Amount Authorized...',
+                           self.browser.contents)
+        #payment_url = self.browser.url
+        #self.browser.open(payment_url)
+        self.browser.getLink("Request callback").click()
+        self.assertMatches('...Valid callback received...',
+                          self.browser.contents)
         self.browser.open(self.manage_student_path)
         self.browser.getControl(
             name="transition").value = ['pay_first_school_fee']
         self.browser.getControl("Save").click()
+        # Reset to returning
         self.browser.getControl(name="transition").value = ['reset6']
         self.browser.getControl("Save").click()
         self.browser.open(self.payments_student_path + '/addop')
         self.browser.getControl("Create ticket").click()
-        self.assertMatches('...This payment ticket already exists...',
+        self.assertMatches('...This type of payment has already been made...',
                            self.browser.contents)
         # Remove all payments so that we can add a school fee payment again
Index: main/waeup.custom/trunk/src/waeup/custom/students/utils.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/students/utils.py	(revision 7418)
+++ main/waeup.custom/trunk/src/waeup/custom/students/utils.py	(revision 7419)
@@ -1,4 +1,20 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
 import grok
-from waeup.sirp.students.vocabularies import academic_sessions_vocab
 from waeup.sirp.students.workflow import CLEARED, RETURNING
 from waeup.sirp.students.utils import StudentsUtils
@@ -31,5 +47,5 @@
     grok.implements(IStudentsUtils)
 
-    def get_payment_details(self, category, student):
+    def getPaymentDetails(self, category, student):
         d = {}
         d['surcharge_1'] = d['surcharge_2'] = d['surcharge_3'] = 0
@@ -60,5 +76,4 @@
             d['amount'] = get_school_fee(student, d['surcharge_1'] + d['surcharge_2'])
             code = student['studycourse'].certificate.code
-            #session_string = academic_sessions_vocab.by_value[p_session + 1].title
             d['p_item'] = code
             d['p_session'] += 1
Index: main/waeup.custom/trunk/src/waeup/custom/testing.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/testing.py	(revision 7418)
+++ main/waeup.custom/trunk/src/waeup/custom/testing.py	(revision 7419)
@@ -1,2 +1,19 @@
+## $Id$
+##
+## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
+## This program is free software; you can redistribute it and/or modify
+## it under the terms of the GNU General Public License as published by
+## the Free Software Foundation; either version 2 of the License, or
+## (at your option) any later version.
+##
+## This program is distributed in the hope that it will be useful,
+## but WITHOUT ANY WARRANTY; without even the implied warranty of
+## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+## GNU General Public License for more details.
+##
+## You should have received a copy of the GNU General Public License
+## along with this program; if not, write to the Free Software
+## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
+##
 """Testing support for :mod:`waeup.custom`.
 """
Index: main/waeup.custom/trunk/src/waeup/custom/tests/test_configuration.py
===================================================================
--- main/waeup.custom/trunk/src/waeup/custom/tests/test_configuration.py	(revision 7418)
+++ main/waeup.custom/trunk/src/waeup/custom/tests/test_configuration.py	(revision 7419)
@@ -1,2 +1,4 @@
+## $Id$
+##
 ## Copyright (C) 2011 Uli Fouquet & Henrik Bettermann
 ## This program is free software; you can redistribute it and/or modify