Index: main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_browser.py
===================================================================
--- main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_browser.py	(revision 7424)
+++ main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_browser.py	(revision 7426)
@@ -79,5 +79,4 @@
         # Add an applicants container
         applicantscontainer = ApplicantsContainer()
-        #applicantscontainer.ac_prefix = 'APP'
         applicantscontainer.code = u'app2009'
         applicantscontainer.prefix = 'app'
@@ -140,5 +139,6 @@
         # applicant object created.
         self.browser.open(self.login_path)
-        self.browser.getControl(name="form.login").value = self.applicant.applicant_id
+        self.browser.getControl(
+            name="form.login").value = self.applicant.applicant_id
         self.browser.getControl(name="form.password").value = 'apwd'
         self.browser.getControl("Login").click()
@@ -170,6 +170,6 @@
         self.assertFalse(
             'Manage' in self.browser.contents)
-
-    
+        return
+
     def test_anonymous_no_actions(self):
         # Make sure anonymous users cannot access actions
@@ -198,4 +198,5 @@
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
         self.assertEqual(self.browser.url, self.manage_root_path)
+        return
 
     def test_manage_actions_access(self):
@@ -245,6 +246,6 @@
         self.browser.getControl(name="form.provider").value = [
             'waeup.sirp.applicants.ApplicantsContainer']
-        #self.browser.getControl(name="form.ac_prefix").value = ['APP']
-        self.browser.getControl(name="form.application_category").value = ['basic']
+        self.browser.getControl(
+            name="form.application_category").value = ['basic']
         self.browser.getControl("Add applicants container").click()
         self.assertTrue('Added:' in self.browser.contents)
@@ -257,8 +258,9 @@
         self.browser.getControl(name="form.provider").value = [
             'waeup.sirp.applicants.ApplicantsContainer']
-        #self.browser.getControl(name="form.ac_prefix").value = ['APP']
-        self.browser.getControl(name="form.application_category").value = ['basic']
+        self.browser.getControl(
+            name="form.application_category").value = ['basic']
         self.browser.getControl("Add applicants container").click()
-        self.assertTrue('exists already in the database' in self.browser.contents)
+        self.assertTrue('exists already in the database'
+                        in self.browser.contents)
         self.browser.open(self.manage_root_path)
         ctrl = self.browser.getControl(name='val_id')
@@ -272,5 +274,6 @@
             'waeup.sirp.applicants.ApplicantsContainer']
         #self.browser.getControl(name="form.ac_prefix").value = ['APP']
-        self.browser.getControl(name="form.application_category").value = ['basic']
+        self.browser.getControl(
+            name="form.application_category").value = ['basic']
         self.browser.getControl("Add applicants container").click()
         del self.app['applicants']['app2010']
@@ -322,5 +325,6 @@
         self.browser.getControl("Save").click()
         self.assertMatches('...Form has been saved...', self.browser.contents)
-        self.assertMatches('...Application started by Manager...', self.browser.contents)
+        self.assertMatches('...Application started by Manager...',
+                           self.browser.contents)
         self.browser.open(self.view_path)
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
@@ -334,5 +338,6 @@
         self.browser.getControl(name="control_password").value = 'secre'
         self.browser.getControl("Save").click()
-        self.assertMatches('...Passwords do not match...', self.browser.contents)
+        self.assertMatches('...Passwords do not match...',
+                           self.browser.contents)
         self.browser.getControl(name="password").value = 'secret'
         self.browser.getControl(name="control_password").value = 'secret'
@@ -342,5 +347,6 @@
         self.browser.open(self.slip_path)
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
-        self.assertEqual(self.browser.headers['Content-Type'], 'application/pdf')
+        self.assertEqual(self.browser.headers['Content-Type'],
+                         'application/pdf')
         # Managers can view applicants even if certificate has been removed
         del self.app['faculties']['fac1']['dep1'].certificates['CERT1']
@@ -601,6 +607,8 @@
         self.fill_correct_values()
         self.browser.getControl("Add online payment ticket").click()
-        self.assertMatches('...Payment ticket created...', self.browser.contents)
-        # Payment ticket can be removed if they haven't received a valid callback
+        self.assertMatches('...Payment ticket created...',
+                           self.browser.contents)
+        # Payment ticket can be removed if they haven't received a
+        # valid callback
         ctrl = self.browser.getControl(name='val_id')
         value = ctrl.options[0]
@@ -634,5 +642,6 @@
         self.browser.getLink("Download payment receipt").click()
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
-        self.assertEqual(self.browser.headers['Content-Type'], 'application/pdf')
+        self.assertEqual(self.browser.headers['Content-Type'],
+                         'application/pdf')
         # Applicant is is in state 'paid'
         self.browser.open(self.view_path)
@@ -665,5 +674,6 @@
         # since the passport confirmation box was not ticked
         self.assertTrue(
-            'Passport picture confirmation box not ticked' in self.browser.contents)
+            'Passport picture confirmation box not ticked'
+            in self.browser.contents)
         self.browser.getControl(name="confirm_passport").value = True
         self.browser.getControl("Final Submit").click()
@@ -675,5 +685,4 @@
             'The requested form is locked' in self.browser.contents)
         self.browser.goBack(count=1)
-        #import pdb; pdb.set_trace()
         self.browser.getControl("Final Submit").click()
         self.assertTrue(
@@ -696,5 +705,4 @@
         self.browser.open(self.edit_path)
         self.assertEqual(self.browser.headers['Status'], '200 Ok')
-        #print self.browser.contents
         self.assertTrue(
             'The requested form is locked' in self.browser.contents)
@@ -720,4 +728,5 @@
         self.assertEqual(self.browser.url,
             self.container_path + '/registration_complete?email=xx%40yy.zz')
+        return
 
     def test_register_applicant_wo_phone(self):
@@ -732,3 +741,3 @@
         self.assertEqual(self.browser.url,
             self.container_path + '/registration_complete?email=xx%40yy.zz')
-
+        return